#ifdef GL_ES//for discriminate GLES & GL
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#else
#define highp
#define mediump
#define lowp
#endif
varying vec2 v_texcoord;
varying vec2 v_texcoordMin;
varying vec2 v_texcoordMax;

uniform sampler2D s_texture;
uniform sampler2D s_textureMask;
uniform sampler2D s_textureMaterial;
uniform vec4 u_color;
uniform int u_fragType;
uniform int u_useColor;
uniform float u_stepMinX;
uniform float u_stepMinY;
uniform float u_stepMaxX;
uniform float u_stepMaxY;

float expansion(float stepX , float stepY)
{
	float res = texture2D(s_textureMask,v_texcoord).g;
	float temp = 0.0;
	int i = 0;
	int j = 0;
	
	for( i = -5 ; i <= 5 ; i ++ )
	{
		for( j = -5 ; j <= 5 ; j ++)
		{
			temp =  texture2D(s_textureMask,v_texcoord + vec2(stepX*float(i) , stepY*float(j))).g;
			if(temp > res) res = temp;
		}
	}
	//temp =  texture2D(s_textureMask,v_texcoord + vec2(stepX*0.707 , stepY*0.707)).g;
	//if(temp > res) res = temp;
	//
	//temp =  texture2D(s_textureMask,v_texcoord + vec2(-stepX*0.707 , -stepY*0.707)).g;
	//if(temp > res) res = temp;
	//
	//temp =  texture2D(s_textureMask,v_texcoord + vec2(-stepX*0.707 , stepY*0.707)).g;
	//if(temp > res) res = temp;
	//
	//temp =  texture2D(s_textureMask,v_texcoord + vec2(stepX*0.707 , -stepY*0.707)).g;
	//if(temp > res) res = temp;
	//
	//temp =  texture2D(s_textureMask,v_texcoord + vec2(stepX , 0.0)).g;
	//if(temp > res) res = temp;
	//
	//temp =  texture2D(s_textureMask,v_texcoord + vec2(0.0 , -stepY)).g;
	//if(temp > res) res = temp;
	//
	//temp =  texture2D(s_textureMask,v_texcoord + vec2(-stepX , 0.0)).g;
	//if(temp > res) res = temp;
	//
	//temp =  texture2D(s_textureMask,v_texcoord + vec2(0.0 , -stepY)).g;
	//if(temp > res) res = temp;
	
	return res;
}

void main()
{
	//Show mask
	//float alphaSrc = texture2D(s_textureMask,v_texcoord).g;
	//if(alphaSrc > 0.0)
	//{
	//	gl_FragColor = vec4(alphaSrc,alphaSrc,alphaSrc,alphaSrc);
	//	return;
	//}
		
	float alpha = 0.0;
	if(u_fragType == 0)
	{
		float alphaMin = expansion(u_stepMinX , u_stepMinY);
		float alphaMax = expansion(u_stepMaxX , u_stepMaxY);
		
		if(alphaMax > alphaMin )
		{
			alpha = alphaMax - alphaMin;
			alpha *= 2.5;
		}
	}
	else if(u_fragType == 1){
		float alphaMin = texture2D(s_textureMask,v_texcoordMin).g;
		float alphaMax = texture2D(s_textureMask,v_texcoordMax).g;
		
		if(alphaMax > alphaMin )
		{
			alpha = alphaMax - alphaMin;
			alpha *= 3.0;
		}
		
		
		//if(alphaMax > 0.0)
		//{
		//	gl_FragColor = vec4(1.0,0.0,0.0,1.0);
		//	return;
		//}
		//if(alphaMin > 0.0)
		//{
		//	gl_FragColor = vec4(0.0,1.0,0.0,1.0);
		//	return;
		//}
		
	}
	
	vec4 dstColor ;
	if(u_useColor == 1)
	{
		dstColor = u_color;
	}
	else{
		dstColor = texture2D(s_textureMaterial,v_texcoord);
	}
	
	vec4 srcColor = texture2D(s_texture,v_texcoord);
	
	gl_FragColor = mix(srcColor , dstColor , alpha);
}